import PyLibrary.funciones_comunes as fc
import pandas as pd
import os
import re
import logging
from openpyxl.utils.escape import unescape

def complete_emptys(tipo_PLC,codigo_columna_maestra, archivo_maestro, target_lang_code, second_lang_code):
    if not os.path.exists(archivo_maestro):
        print("El archivo maestro no existe.")
        return

    target_col = target_lang_code
    second_col = second_lang_code

    df_maestro = fc.read_dataframe_with_cleanup_retries(archivo_maestro)

    # Configurar el logger
    logger = fc.configurar_logger()

    # Iterar sobre las filas del archivo de traducción para actualizar el maestro
    for index, fila in df_maestro.iterrows():
        clave = fila[codigo_columna_maestra]
        if fila[target_col] == "" or pd.isnull(fila[target_col]):
            if pd.notnull(fila[second_col]) and fila[second_col] != "":
                df_maestro.loc[
                    df_maestro[codigo_columna_maestra] == clave, target_col
                ] = fila[second_col]
                logger.info(
                    f'Fila {index}, Columna {target_col}: " actualizado a "{fila[second_col]}"'
                )
            else:
                df_maestro.loc[
                    df_maestro[codigo_columna_maestra] == clave, target_col
                ] = fc.compactar_celda_traducida(tipo_PLC, fila[codigo_columna_maestra])
                logger.info(
                    f'Fila {index}, Columna {target_col}: " actualizado a "{fila[codigo_columna_maestra]}"'
                )

    # Guardar el archivo maestro actualizado
    fc.save_dataframe_with_retries(
        df_maestro, output_path=archivo_maestro
    )
    print(
        f"Traducciones importadas y archivo maestro actualizado: {archivo_maestro}."
    )

def run(tipo_PLC, codigo_columna_maestra, seleccion_idioma, seleccion_idioma_secundario):
    archivo_maestro = f".\\data\\1_hmi_master_translates_{tipo_PLC}.xlsx"

    if seleccion_idioma not in fc.IDIOMAS:
        print("Selección inválida.")
        exit

    if seleccion_idioma_secundario not in fc.IDIOMAS:
        print("Selección inválida.")
        exit

    _, target_lang_code = fc.IDIOMAS[seleccion_idioma]
    _, second_lang_code = fc.IDIOMAS[seleccion_idioma_secundario]
    complete_emptys(tipo_PLC, codigo_columna_maestra, archivo_maestro, target_lang_code, second_lang_code)

if __name__ == "__main__":
    tipo_PLC = "siemens"
    codigo_columna_maestra = "it-IT"
    fc.mostrar_idiomas()
    seleccion_idioma = int(input("Introduce el número del idioma de destino: "))
    if seleccion_idioma not in fc.IDIOMAS:
        print("Selección inválida.")
        exit
    seleccion_idioma_secundario = int(
        input(
            "Introduce el número del idioma de secundario para copiar desde en caso de vacios: "
        )
    )
    if seleccion_idioma_secundario not in fc.IDIOMAS:
        print("Selección inválida.")
        exit
    run(tipo_PLC, codigo_columna_maestra, seleccion_idioma, seleccion_idioma_secundario)

